<?php

trait WilokeGridVimeo {
	public function renderVimeoItem($aItem, $itemStyle, $aShortcodeSettings){

	}

	public function vimeoOutput($data){
		$aSettings = get_option('_pi_vimeo_settings');

		if ( empty($aSettings) ){
			return array(
				'message' => esc_html__('Google API key is required: Wiloke Grid -> Google API Settings', 'wiloke-grid')
			);
		}

		$oVimeo = new \Vimeo\Vimeo($aSettings['client_id'], $aSettings['client_secret']);
		try{
			$template = $this->template('template/', $data['shortcode']['item_style'], 'vimeo');
			$paged = isset($data['paged']) ? abs($data['paged']) : 1;
			$aVideos = $oVimeo->request('/me/albums/'.$data['shortcode']['wil_vimeo_album_id'].'/videos/', ['per_page' => $data['posts_page_page'], 'page'=>$paged], 'GET');
			switch ( $data['shortcode']['wil_thumbnail_size'] ){
				case 'default':
					$imgName = '200x150.jpg';
					break;
				case 'medium':
					$imgName = '960x540.jpg';
					break;
				case 'high':
					$imgName = '960x540.jpg';
					break;
				case 'maxres':
					$imgName = '1200x720.jpg';
					break;
			}

			$animation = (isset($data['shortcode']['wil_animation']) && $data['shortcode']['wil_animation'] != 'none') ? 'wow ' . $data['shortcode']['wil_animation'] : '';
			$animationHover = (isset($data['shortcode']['wil_animation_hover']) && $data['shortcode']['wil_animation_hover'] != '' ) ? $data['shortcode']['wil_animation_hover'] : '';

			ob_start();
			$index = 0;
			foreach ($aVideos['body']['data'] as $aItem){
				$delay = $index * 0.15;
				?>
				<div class="grid-item <?php echo esc_attr($animation) ?>" data-wow-delay="<?php echo esc_attr($delay) ?>s">
					<div class="grid-item__inner">
						<div class="grid-item__content-wrapper">
						<?php
						include $template;
						?>
						</div>
					</div>
				</div>
				<?php
				$index++;
			}
			$output = ob_get_contents();
			ob_end_clean();
			$output = apply_filters('wiloke_isotope_vimeo_item', $output, $aVideos, $data);

			return array(
				'status' 		=> 200,
				'data'	 		=> $output,
				'paged'			=> $paged,
				'loadedAll'		=> empty($aVideos['body']['paging']['next']),
				'message'		=> esc_html__('Success!', 'wiloke-grid')
			);
		}catch (Exception $oException){
			return array(
				'message' => esc_html__('Wrong Vimeo ID', 'wiloke-grid')
			);
		}
	}
}