<?php
if ( isset($_POST['instagram'])) {
	$this->updateSettings('_pi_instagram_settings', $_POST['instagram']);
}

$aInstagram = get_option('_pi_instagram_settings');
$aInstagram = $aInstagram ? $aInstagram : array('userid' => '', 'profile_picture'=>'', 'access_token' => '', 'username'=>'', 'profile_picture', 'cache_interval'=>864000);
$instagramRedirectUri = 'https://www.instagram.com/oauth/authorize/?client_id=54da896cf80343ecb0e356ac5479d9ec&scope=basic+public_content&redirect_uri=http://api.web-dorado.com/instagram/?return_url='.admin_url('admin.php?page=wiloke-grid') . '&response_type=token';

if ( isset($_GET['access_token']) && !empty($_GET['access_token']) )
{
	$url       = 'https://api.instagram.com/v1/users/self/?access_token='.$_GET['access_token'];
	$oResponse = wp_remote_get($url, array( 'timeout' => 120, 'httpversion' => '1.1' ) );

	if ( !empty($oResponse) && !is_wp_error($oResponse) )
	{
		$oResponse = $oResponse['body'];
		$oResponse = json_decode($oResponse);

		if ( $oResponse->meta->code == 200 )
		{
			$aInstagram['username']         = $oResponse->data->username;
			$aInstagram['userid']           = $oResponse->data->id;
			$aInstagram['profile_picture']  = $oResponse->data->profile_picture;
			$aInstagram['access_token']     = $_GET['access_token'];
			update_option('_pi_instagram_settings', $aInstagram);
		}
	}

	unset($_GET['access_token']);
}
?>
<div class="ui segment">
	<h3 class="ui heading">Instagram Settings</h3>
	<div class="field">
		<label for="sign-in-with-instagram">Sign in with Instagram</label>
		<div class="ui message info">
			<a id="sign-in-with-instagram" style="height: auto;" class="ui button violet" href="<?php echo esc_url($instagramRedirectUri); ?>">Get My Instagram API</a>
		</div>
		<div class="ui message info">
			<?php
			if ( !empty($aInstagram['profile_picture']) )
			{
				?>
				<img style="width: 50px; height: 50px; border-radius: 100%;" src="<?php echo esc_url($aInstagram['profile_picture']); ?>" alt="Profile Picture" />
				<?php
			}
			?>
			<input id="profilepicture" type="hidden" name="instagram[profile_picture]" value="<?php echo esc_url($aInstagram['profile_picture']); ?>"/>
		</div>
	</div>

	<div class="field">
		<label for="userid">User ID</label></th>
		<input id="userid" type="text" name="instagram[userid]" value="<?php echo esc_attr($aInstagram['userid']); ?>"/>
	</div>

	<div class="field">
		<label for="username">Username</label>
		<input id="username" type="text" name="instagram[username]" value="<?php echo esc_attr($aInstagram['username']); ?>"/>
	</div>

	<div class="field">
		<label for="access-token">Access Token</label>
		<input id="access-token" type="text" name="instagram[access_token]" value="<?php echo esc_attr($aInstagram['access_token']); ?>"/>
	</div>

	<div class="field">
		<label for="cache-interval">Cache Interval</label>
		<input id="cache-interval" type="text" name="instagram[cache_interval]"
			       value="<?php echo esc_attr($aInstagram['cache_interval']); ?>"/>
		<div class="ui message info"><?php esc_html_e('Leave empty to clear cache. Unit: mini seconds', 'wiloke'); ?></div>
	</div>
	<button class="ui button green" style="height: auto" type="submit">Submit</button>
</div>